from .wrappers import Communicator


def parallel(func):
    """
    Decorator to convert a function that acts over a list to parallelize
    the function by splitting the input list between the processes
    :param func:
    :return:
    """
    def wrapper(*args, **kwargs):
        c = Communicator()
        if args:
            args = (c.scatter(args[0]),)
        return c.gather(func(*args, **kwargs))

    return wrapper


def initialization(func):
    """
    Decorator to convert a function will only be executed in the root process
    :param func:
    :return:
    """
    def wrapper(*args, **kwargs):
        c = Communicator()
        if c.is_root:
            return func(*args, **kwargs)
        else:
            return None

    return wrapper