# Function that splits a list in parts of similar size
def split_list(input_list, parts, round_robin=False):
    # Some checks
    assert parts > 0, "Number of parts should be bigger than 0!"
    # If input is a numpy array, convert it to list
    if not isinstance(input_list, list):
        input_list = list(input_list)

    # Size of the output lists
    output_list_size = int(len(input_list) / parts)

    # Residual
    residual = len(input_list) % parts

    # Create empty output lists
    output_lists = [[] for i in range(parts)]

    if round_robin is False:
        # Put the elements of each part
        for i in range(parts):
            for j in range(output_list_size):
                output_lists[i].append(input_list.pop(0))
            if i < residual:
                output_lists[i].append(input_list.pop(0))
    else:
        while len(input_list) > 0:
            for i in range(parts):
                try:
                    output_lists[i].append(input_list.pop(0))
                except IndexError:
                    break

    return output_lists